--- boost/config/compiler/clang.hpp
+++ boost/config/compiler/clang.hpp
@@ -240,6 +240,16 @@
 #  define BOOST_NO_CXX11_INLINE_NAMESPACES
 #endif
 
+// Apple Clang uses libc++ by default on Mavericks (OS X 10.9)  and higher
+// Apple Clang uses libstdc++ by default on Mountain Lion (OS X 10.8) and lower
+
+#ifdef __APPLE__
+#include <ciso646>
+#ifndef _LIBCPP_VERSION
+#  define BOOST_APPLE_CLANG_NO_LIBCXX
+#endif
+#endif
+
 #if !__has_feature(cxx_override_control)
 #  define BOOST_NO_CXX11_FINAL
 #endif
--- boost/multi_index/detail/vartempl_support.hpp
+++ boost/multi_index/detail/vartempl_support.hpp
@@ -40,11 +40,12 @@
  */
 
 #include <boost/config.hpp>
 
 #if defined(BOOST_NO_CXX11_RVALUE_REFERENCES)||\
-    defined(BOOST_NO_CXX11_VARIADIC_TEMPLATES)
+    defined(BOOST_NO_CXX11_VARIADIC_TEMPLATES)||\
+    defined(BOOST_APPLE_CLANG_NO_LIBCXX)
 
 #include <boost/move/core.hpp>
 #include <boost/move/utility.hpp>
 #include <boost/preprocessor/arithmetic/add.hpp>
 #include <boost/preprocessor/arithmetic/sub.hpp>
